package index.alg.analyse;

import index.entity.Point;
import java.io.FileNotFoundException;
import java.util.ArrayList;
import java.util.Date;

public class CalHpTimeDistance {

    ArrayList<Long> diffList = new ArrayList<>();
    Double avg =0.;
    ArrayList<Integer> distList = new ArrayList<>();

    public CalHpTimeDistance(ArrayList<ArrayList<Date>> dateForAna){

            for (int i = 0 ; i< dateForAna.size();i++){
                ArrayList<Date> dateArrayList = dateForAna.get(i);
                for (int j = 0 ; j < dateArrayList.size() - 1;j++){

                    int k = j + 1;
                    Date dateJ = dateArrayList.get(j);
                    Date dateK = dateArrayList.get(k);
                    long diff = dateK.getTime() - dateJ.getTime();
                    diffList.add(diff);
                }
            }

    }

    public double getAvDiff(){

        for (int i = 0;i < diffList.size();i++){
            avg = avg + diffList.get(i);
        }
        avg = avg / diffList.size();

        return avg;

    }

    public void buildDistribution(int binNum) throws FileNotFoundException {

        for (int i = 0 ; i < binNum;i++){
            distList.add(0);
        }

        long maxDiff = 0;
        long minDiff = 0;

        for (int i = 0;i< diffList.size();i++){

            long diff = diffList.get(i);

            if (diff >= maxDiff && diff < 5000){

                maxDiff = diff;

            }
            if (diff <= minDiff){

                minDiff = diff;
            }
        }

        double binDis = (maxDiff - minDiff) / binNum;

        for (int i = 0 ; i < diffList.size();i++){

            long diff = diffList.get(i);
            Integer index = (int)((diff - minDiff) / binDis);
            if (index >= binNum){
                index = binNum - 1;
            }
            Integer oldValue = distList.get(index);
            distList.set(index,oldValue + 1);
        }

        ArrayList<Point> pointArrayList = new ArrayList<>();
        for (int i = 0 ; i < distList.size();i++){

            Double x = i * binDis + minDiff + 0.5 * binDis;
            Double y = distList.get(i).doubleValue();
            Point point = new Point();
            point.setColX(x);
            point.setColY(y);
            pointArrayList.add(point);
        }

    }





}
