package index.plot;

import index.adjust.PointXYCorRevise;
import index.db.DbOperate;
import index.entity.Point;
import index.file.OperateFile;

import java.io.FileNotFoundException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Map;

public class Plot {

    String basicFilePath;

    public Plot(String basicFilePath){

        this.basicFilePath = basicFilePath;

    }

    ArrayList<Map> mapFileArrayList = new ArrayList<>();

    public void collectData(String fileName,ArrayList<Point> pointArrayList){

        Map map = new HashMap();
        map.put("FILE_NAME",fileName);
        map.put("POINTS_LIST",pointArrayList);
        mapFileArrayList.add(map);

    }

    public void normalPrint() throws FileNotFoundException {

        OperateFile operateFile = new OperateFile();

        for (int i = 0 ; i < mapFileArrayList.size();i++){

            Map map = mapFileArrayList.get(i);
            String fileName = map.get("FILE_NAME").toString();
            ArrayList<Point> pointArrayList = (ArrayList<Point>)map.get("POINTS_LIST");
            operateFile.printPoint(basicFilePath + fileName,pointArrayList);
        }

    }


    //特殊用途
    public void revisePlot(ArrayList<Map> mapFileArrayList) throws FileNotFoundException {

        OperateFile operateFile = new OperateFile();
        PointXYCorRevise pointXYCorRevise = new PointXYCorRevise();

        for (int i = 0 ; i < mapFileArrayList.size();i++){

            Map map = mapFileArrayList.get(i);
            String fileName = map.get("FILE_NAME").toString();
            ArrayList<Point> pointArrayList = (ArrayList<Point>)map.get("POINTS_LIST");
            pointArrayList = pointXYCorRevise.revise(pointArrayList);
            operateFile.printPoint(basicFilePath + fileName,pointArrayList);
        }

    }






}
